//
// Vladi Gergov
//

# include <stdio.h>
# include <iostream.h>
# include <math.h>
# include <stdlib.h>

void falsi( void );
void atiken( void );
double evalf( double x );
double evalg( double x );

int main( void )
{

	int choice;
	printf("\n1 - Falsi | 2 - Aitken\n");
	printf("\nChoose Your Algorithm: ");
	cin >> choice;
	printf("\n");

	if( choice == 1 )
		falsi();
	else
		atiken();

}

void falsi( void )
{

	int count;
	double a, b, c, root, err, pastc, fata, fatb, evalabs;

	a = 0.5;
	b = 1.2;
	err = .000001;
	count = 1;	
	pastc = 2 * b - a;
	
	while(1)
	{
		fatb = evalf(b);
		fata = evalf(a); 
		
		c = b - fatb * ( ( b - a ) / ( fatb - fata ) );
		
		printf("| Count: %d | a = %f | f(a) = %f |\n", count, a, fata);	
		
		if( ( fatb * fata ) <= 0 )
			a = c;
		else
			b = c;
		
		evalabs = fabsl( c - pastc );

		if( evalabs <= err )
		{
			root = c;
			printf("\nRoot = %lf", root);
			printf("\nIteration Number: %d\n\n", count);
			break;
		}
		else
		{
			pastc = c;
			count = count + 1;
		}
	}
}

void atiken( void )
{
	int count;
	double  x0, x1, x2, m, err, root;

	count = 1;
	err = 1.5 * pow( 10, -6 );
	x0 = 4;

	while(1)
	{
		x1 = evalg(x0);
		x2 = evalg(x1);

		m = x2 - pow( ( x2 - x1 ), 2 ) / ( ( x2 - x1 ) - ( x1 - x0 ) );

		printf("| Count: %d | x0 = %f | g(x0) = %f |\n", count, x0, x1); 

		if( fabsl( m - x2 ) <= err)
		{
			root = m;
			printf("\nRoot = %f", root);
			printf("\nIteration Number: %d\n",count);
			break;
		}
		else
		x0 = m;
		count = count + 1;
	}
}

double evalf( double x )
{
	return( pow( x, 6 ) - x - 1 );
	
}

double evalg( double x )
{

	return( 1.6 + 0.99 * cos( x ) );

}

//
// EOF
//
